summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--GentooX Breeze Dark Transparent.tar.gzbin0 -> 363009 bytes
-rw-r--r--ToDo.txt10
-rwxr-xr-xarch-chroot347
-rwxr-xr-xgenfstab494
-rwxr-xr-xgentoox_build.sh26
-rw-r--r--patches/www-client/firefox/firefox-branded-icons.patch51
-rw-r--r--patches/www-client/firefox/firefox-kde.patch283
-rw-r--r--patches/www-client/firefox/mozilla-kde.patch1940
-rwxr-xr-xpostinstall.sh73
-rw-r--r--zfs-ungpl-rcu_read_unlock-export.diff22
10 files changed, 3206 insertions, 40 deletions
diff --git a/GentooX Breeze Dark Transparent.tar.gz b/GentooX Breeze Dark Transparent.tar.gz
new file mode 100644
index 0000000..dac3436
--- /dev/null
+++ b/GentooX Breeze Dark Transparent.tar.gz
Binary files differ
diff --git a/ToDo.txt b/ToDo.txt
index 7bde892..6cb4203 100644
--- a/ToDo.txt
+++ b/ToDo.txt
@@ -21,4 +21,14 @@ for (i=0;i<Desktops.length;i++) {
- adjust weston USE flags
- adjust mpv USE flags
+- gentoox_build.sh should consider doing these at the end of build:
+ emerge -avuDN --with-bdeps=y @world
+ revdep-rebuild -ip
+ another point to consider is building ~ąmd64 stage3 seed tarball from get go
+
- read eselect news messages
+
+
+- preliminary install instructions
+ unsquash -f -i -d /mnt/install/ /mnt/cdrom/image.squashfs
+
diff --git a/arch-chroot b/arch-chroot
new file mode 100755
index 0000000..56099ed
--- /dev/null
+++ b/arch-chroot
@@ -0,0 +1,347 @@
+#!/bin/bash
+
+shopt -s extglob
+
+# generated from util-linux source: libmount/src/utils.c
+declare -A pseudofs_types=([anon_inodefs]=1
+ [autofs]=1
+ [bdev]=1
+ [bpf]=1
+ [binfmt_misc]=1
+ [cgroup]=1
+ [cgroup2]=1
+ [configfs]=1
+ [cpuset]=1
+ [debugfs]=1
+ [devfs]=1
+ [devpts]=1
+ [devtmpfs]=1
+ [dlmfs]=1
+ [efivarfs]=1
+ [fuse.gvfs-fuse-daemon]=1
+ [fusectl]=1
+ [hugetlbfs]=1
+ [mqueue]=1
+ [nfsd]=1
+ [none]=1
+ [pipefs]=1
+ [proc]=1
+ [pstore]=1
+ [ramfs]=1
+ [rootfs]=1
+ [rpc_pipefs]=1
+ [securityfs]=1
+ [sockfs]=1
+ [spufs]=1
+ [sysfs]=1
+ [tmpfs]=1)
+
+# generated from: pkgfile -vbr '/fsck\..+' | awk -F. '{ print $NF }' | sort
+declare -A fsck_types=([cramfs]=1
+ [exfat]=1
+ [ext2]=1
+ [ext3]=1
+ [ext4]=1
+ [ext4dev]=1
+ [jfs]=1
+ [minix]=1
+ [msdos]=1
+ [reiserfs]=1
+ [vfat]=1
+ [xfs]=1)
+
+out() { printf "$1 $2\n" "${@:3}"; }
+error() { out "==> ERROR:" "$@"; } >&2
+warning() { out "==> WARNING:" "$@"; } >&2
+msg() { out "==>" "$@"; }
+msg2() { out " ->" "$@";}
+die() { error "$@"; exit 1; }
+
+ignore_error() {
+ "$@" 2>/dev/null
+ return 0
+}
+
+in_array() {
+ local i
+ for i in "${@:2}"; do
+ [[ $1 = "$i" ]] && return 0
+ done
+ return 1
+}
+
+chroot_add_mount() {
+ mount "$@" && CHROOT_ACTIVE_MOUNTS=("$2" "${CHROOT_ACTIVE_MOUNTS[@]}")
+}
+
+chroot_maybe_add_mount() {
+ local cond=$1; shift
+ if eval "$cond"; then
+ chroot_add_mount "$@"
+ fi
+}
+
+chroot_setup() {
+ CHROOT_ACTIVE_MOUNTS=()
+ [[ $(trap -p EXIT) ]] && die '(BUG): attempting to overwrite existing EXIT trap'
+ trap 'chroot_teardown' EXIT
+
+ chroot_add_mount proc "$1/proc" -t proc -o nosuid,noexec,nodev &&
+ chroot_add_mount sys "$1/sys" -t sysfs -o nosuid,noexec,nodev,ro &&
+ ignore_error chroot_maybe_add_mount "[[ -d '$1/sys/firmware/efi/efivars' ]]" \
+ efivarfs "$1/sys/firmware/efi/efivars" -t efivarfs -o nosuid,noexec,nodev &&
+ chroot_add_mount udev "$1/dev" -t devtmpfs -o mode=0755,nosuid &&
+ chroot_add_mount devpts "$1/dev/pts" -t devpts -o mode=0620,gid=5,nosuid,noexec &&
+ chroot_add_mount shm "$1/dev/shm" -t tmpfs -o mode=1777,nosuid,nodev &&
+ chroot_add_mount /run "$1/run" --bind &&
+ chroot_add_mount tmp "$1/tmp" -t tmpfs -o mode=1777,strictatime,nodev,nosuid
+}
+
+chroot_teardown() {
+ if (( ${#CHROOT_ACTIVE_MOUNTS[@]} )); then
+ umount "${CHROOT_ACTIVE_MOUNTS[@]}"
+ fi
+ unset CHROOT_ACTIVE_MOUNTS
+}
+
+try_cast() (
+ _=$(( $1#$2 ))
+) 2>/dev/null
+
+valid_number_of_base() {
+ local base=$1 len=${#2} i=
+
+ for (( i = 0; i < len; i++ )); do
+ try_cast "$base" "${2:i:1}" || return 1
+ done
+
+ return 0
+}
+
+mangle() {
+ local i= chr= out=
+ local {a..f}= {A..F}=
+
+ for (( i = 0; i < ${#1}; i++ )); do
+ chr=${1:i:1}
+ case $chr in
+ [[:space:]\\])
+ printf -v chr '%03o' "'$chr"
+ out+=\\
+ ;;
+ esac
+ out+=$chr
+ done
+
+ printf '%s' "$out"
+}
+
+unmangle() {
+ local i= chr= out= len=$(( ${#1} - 4 ))
+ local {a..f}= {A..F}=
+
+ for (( i = 0; i < len; i++ )); do
+ chr=${1:i:1}
+ case $chr in
+ \\)
+ if valid_number_of_base 8 "${1:i+1:3}" ||
+ valid_number_of_base 16 "${1:i+1:3}"; then
+ printf -v chr '%b' "${1:i:4}"
+ (( i += 3 ))
+ fi
+ ;;
+ esac
+ out+=$chr
+ done
+
+ printf '%s' "$out${1:i}"
+}
+
+optstring_match_option() {
+ local candidate pat patterns
+
+ IFS=, read -ra patterns <<<"$1"
+ for pat in "${patterns[@]}"; do
+ if [[ $pat = *=* ]]; then
+ # "key=val" will only ever match "key=val"
+ candidate=$2
+ else
+ # "key" will match "key", but also "key=anyval"
+ candidate=${2%%=*}
+ fi
+
+ [[ $pat = "$candidate" ]] && return 0
+ done
+
+ return 1
+}
+
+optstring_remove_option() {
+ local o options_ remove=$2 IFS=,
+
+ read -ra options_ <<<"${!1}"
+
+ for o in "${!options_[@]}"; do
+ optstring_match_option "$remove" "${options_[o]}" && unset 'options_[o]'
+ done
+
+ declare -g "$1=${options_[*]}"
+}
+
+optstring_normalize() {
+ local o options_ norm IFS=,
+
+ read -ra options_ <<<"${!1}"
+
+ # remove empty fields
+ for o in "${options_[@]}"; do
+ [[ $o ]] && norm+=("$o")
+ done
+
+ # avoid empty strings, reset to "defaults"
+ declare -g "$1=${norm[*]:-defaults}"
+}
+
+optstring_append_option() {
+ if ! optstring_has_option "$1" "$2"; then
+ declare -g "$1=${!1},$2"
+ fi
+
+ optstring_normalize "$1"
+}
+
+optstring_prepend_option() {
+ local options_=$1
+
+ if ! optstring_has_option "$1" "$2"; then
+ declare -g "$1=$2,${!1}"
+ fi
+
+ optstring_normalize "$1"
+}
+
+optstring_get_option() {
+ local opts o
+
+ IFS=, read -ra opts <<<"${!1}"
+ for o in "${opts[@]}"; do
+ if optstring_match_option "$2" "$o"; then
+ declare -g "$o"
+ return 0
+ fi
+ done
+
+ return 1
+}
+
+optstring_has_option() {
+ local "${2%%=*}"
+
+ optstring_get_option "$1" "$2"
+}
+
+dm_name_for_devnode() {
+ read dm_name <"/sys/class/block/${1#/dev/}/dm/name"
+ if [[ $dm_name ]]; then
+ printf '/dev/mapper/%s' "$dm_name"
+ else
+ # don't leave the caller hanging, just print the original name
+ # along with the failure.
+ print '%s' "$1"
+ error 'Failed to resolve device mapper name for: %s' "$1"
+ fi
+}
+
+fstype_is_pseudofs() {
+ (( pseudofs_types["$1"] ))
+}
+
+fstype_has_fsck() {
+ (( fsck_types["$1"] ))
+}
+
+
+usage() {
+ cat <<EOF
+usage: ${0##*/} chroot-dir [command]
+
+ -h Print this help message
+ -u <user>[:group] Specify non-root user and optional group to use
+
+If 'command' is unspecified, ${0##*/} will launch /bin/bash.
+
+Note that when using arch-chroot, the target chroot directory *should* be a
+mountpoint. This ensures that tools such as pacman(8) or findmnt(8) have an
+accurate hierarchy of the mounted filesystems within the chroot.
+
+If your chroot target is not a mountpoint, you can bind mount the directory on
+itself to make it a mountpoint, i.e. 'mount --bind /your/chroot /your/chroot'.
+
+EOF
+}
+
+chroot_add_resolv_conf() {
+ local chrootdir=$1 resolv_conf=$1/etc/resolv.conf
+
+ [[ -e /etc/resolv.conf ]] || return 0
+
+ # Handle resolv.conf as a symlink to somewhere else.
+ if [[ -L $chrootdir/etc/resolv.conf ]]; then
+ # readlink(1) should always give us *something* since we know at this point
+ # it's a symlink. For simplicity, ignore the case of nested symlinks.
+ resolv_conf=$(readlink "$chrootdir/etc/resolv.conf")
+ if [[ $resolv_conf = /* ]]; then
+ resolv_conf=$chrootdir$resolv_conf
+ else
+ resolv_conf=$chrootdir/etc/$resolv_conf
+ fi
+
+ # ensure file exists to bind mount over
+ if [[ ! -f $resolv_conf ]]; then
+ install -Dm644 /dev/null "$resolv_conf" || return 1
+ fi
+ elif [[ ! -e $chrootdir/etc/resolv.conf ]]; then
+ # The chroot might not have a resolv.conf.
+ return 0
+ fi
+
+ chroot_add_mount /etc/resolv.conf "$resolv_conf" --bind
+}
+
+while getopts ':hu:' flag; do
+ case $flag in
+ h)
+ usage
+ exit 0
+ ;;
+ u)
+ userspec=$OPTARG
+ ;;
+ :)
+ die '%s: option requires an argument -- '\''%s'\' "${0##*/}" "$OPTARG"
+ ;;
+ ?)
+ die '%s: invalid option -- '\''%s'\' "${0##*/}" "$OPTARG"
+ ;;
+ esac
+done
+shift $(( OPTIND - 1 ))
+
+(( EUID == 0 )) || die 'This script must be run with root privileges'
+(( $# )) || die 'No chroot directory specified'
+chrootdir=$1
+shift
+
+[[ -d $chrootdir ]] || die "Can't create chroot on non-directory %s" "$chrootdir"
+
+if ! mountpoint -q "$chrootdir"; then
+ warning "$chrootdir is not a mountpoint. This may have undesirable side effects."
+fi
+
+chroot_setup "$chrootdir" || die "failed to setup chroot %s" "$chrootdir"
+chroot_add_resolv_conf "$chrootdir" || die "failed to setup resolv.conf"
+
+chroot_args=()
+[[ $userspec ]] && chroot_args+=(--userspec "$userspec")
+
+SHELL=/bin/bash unshare --fork --pid chroot "${chroot_args[@]}" -- "$chrootdir" "$@"
diff --git a/genfstab b/genfstab
new file mode 100755
index 0000000..883e56a
--- /dev/null
+++ b/genfstab
@@ -0,0 +1,494 @@
+#!/bin/bash
+
+shopt -s extglob
+
+# generated from util-linux source: libmount/src/utils.c
+declare -A pseudofs_types=([anon_inodefs]=1
+ [autofs]=1
+ [bdev]=1
+ [bpf]=1
+ [binfmt_misc]=1
+ [cgroup]=1
+ [cgroup2]=1
+ [configfs]=1
+ [cpuset]=1
+ [debugfs]=1
+ [devfs]=1
+ [devpts]=1
+ [devtmpfs]=1
+ [dlmfs]=1
+ [efivarfs]=1
+ [fuse.gvfs-fuse-daemon]=1
+ [fusectl]=1
+ [hugetlbfs]=1
+ [mqueue]=1
+ [nfsd]=1
+ [none]=1
+ [pipefs]=1
+ [proc]=1
+ [pstore]=1
+ [ramfs]=1
+ [rootfs]=1
+ [rpc_pipefs]=1
+ [securityfs]=1
+ [sockfs]=1
+ [spufs]=1
+ [sysfs]=1
+ [tmpfs]=1)
+
+# generated from: pkgfile -vbr '/fsck\..+' | awk -F. '{ print $NF }' | sort
+declare -A fsck_types=([cramfs]=1
+ [exfat]=1
+ [ext2]=1
+ [ext3]=1
+ [ext4]=1
+ [ext4dev]=1
+ [jfs]=1
+ [minix]=1
+ [msdos]=1
+ [reiserfs]=1
+ [vfat]=1
+ [xfs]=1)
+
+out() { printf "$1 $2\n" "${@:3}"; }
+error() { out "==> ERROR:" "$@"; } >&2
+warning() { out "==> WARNING:" "$@"; } >&2
+msg() { out "==>" "$@"; }
+msg2() { out " ->" "$@";}
+die() { error "$@"; exit 1; }
+
+ignore_error() {
+ "$@" 2>/dev/null
+ return 0
+}
+
+in_array() {
+ local i
+ for i in "${@:2}"; do
+ [[ $1 = "$i" ]] && return 0
+ done
+ return 1
+}
+
+chroot_add_mount() {
+ mount "$@" && CHROOT_ACTIVE_MOUNTS=("$2" "${CHROOT_ACTIVE_MOUNTS[@]}")
+}
+
+chroot_maybe_add_mount() {
+ local cond=$1; shift
+ if eval "$cond"; then
+ chroot_add_mount "$@"
+ fi
+}
+
+chroot_setup() {
+ CHROOT_ACTIVE_MOUNTS=()
+ [[ $(trap -p EXIT) ]] && die '(BUG): attempting to overwrite existing EXIT trap'
+ trap 'chroot_teardown' EXIT
+
+ chroot_add_mount proc "$1/proc" -t proc -o nosuid,noexec,nodev &&
+ chroot_add_mount sys "$1/sys" -t sysfs -o nosuid,noexec,nodev,ro &&
+ ignore_error chroot_maybe_add_mount "[[ -d '$1/sys/firmware/efi/efivars' ]]" \
+ efivarfs "$1/sys/firmware/efi/efivars" -t efivarfs -o nosuid,noexec,nodev &&
+ chroot_add_mount udev "$1/dev" -t devtmpfs -o mode=0755,nosuid &&
+ chroot_add_mount devpts "$1/dev/pts" -t devpts -o mode=0620,gid=5,nosuid,noexec &&
+ chroot_add_mount shm "$1/dev/shm" -t tmpfs -o mode=1777,nosuid,nodev &&
+ chroot_add_mount /run "$1/run" --bind &&
+ chroot_add_mount tmp "$1/tmp" -t tmpfs -o mode=1777,strictatime,nodev,nosuid
+}
+
+chroot_teardown() {
+ if (( ${#CHROOT_ACTIVE_MOUNTS[@]} )); then
+ umount "${CHROOT_ACTIVE_MOUNTS[@]}"
+ fi
+ unset CHROOT_ACTIVE_MOUNTS
+}
+
+try_cast() (
+ _=$(( $1#$2 ))
+) 2>/dev/null
+
+valid_number_of_base() {
+ local base=$1 len=${#2} i=
+
+ for (( i = 0; i < len; i++ )); do
+ try_cast "$base" "${2:i:1}" || return 1
+ done
+
+ return 0
+}
+
+mangle() {
+ local i= chr= out=
+ local {a..f}= {A..F}=
+
+ for (( i = 0; i < ${#1}; i++ )); do
+ chr=${1:i:1}
+ case $chr in
+ [[:space:]\\])
+ printf -v chr '%03o' "'$chr"
+ out+=\\
+ ;;
+ esac
+ out+=$chr
+ done
+
+ printf '%s' "$out"
+}
+
+unmangle() {
+ local i= chr= out= len=$(( ${#1} - 4 ))
+ local {a..f}= {A..F}=
+
+ for (( i = 0; i < len; i++ )); do
+ chr=${1:i:1}
+ case $chr in
+ \\)
+ if valid_number_of_base 8 "${1:i+1:3}" ||
+ valid_number_of_base 16 "${1:i+1:3}"; then
+ printf -v chr '%b' "${1:i:4}"
+ (( i += 3 ))
+ fi
+ ;;
+ esac
+ out+=$chr
+ done
+
+ printf '%s' "$out${1:i}"
+}
+
+optstring_match_option() {
+ local candidate pat patterns
+
+ IFS=, read -ra patterns <<<"$1"
+ for pat in "${patterns[@]}"; do
+ if [[ $pat = *=* ]]; then
+ # "key=val" will only ever match "key=val"
+ candidate=$2
+ else
+ # "key" will match "key", but also "key=anyval"
+ candidate=${2%%=*}
+ fi
+
+ [[ $pat = "$candidate" ]] && return 0
+ done
+
+ return 1
+}
+
+optstring_remove_option() {
+ local o options_ remove=$2 IFS=,
+
+ read -ra options_ <<<"${!1}"
+
+ for o in "${!options_[@]}"; do
+ optstring_match_option "$remove" "${options_[o]}" && unset 'options_[o]'
+ done
+
+ declare -g "$1=${options_[*]}"
+}
+
+optstring_normalize() {
+ local o options_ norm IFS=,
+
+ read -ra options_ <<<"${!1}"
+
+ # remove empty fields
+ for o in "${options_[@]}"; do
+ [[ $o ]] && norm+=("$o")
+ done
+
+ # avoid empty strings, reset to "defaults"
+ declare -g "$1=${norm[*]:-defaults}"
+}
+
+optstring_append_option() {
+ if ! optstring_has_option "$1" "$2"; then
+ declare -g "$1=${!1},$2"
+ fi
+
+ optstring_normalize "$1"
+}
+
+optstring_prepend_option() {
+ local options_=$1
+
+ if ! optstring_has_option "$1" "$2"; then
+ declare -g "$1=$2,${!1}"
+ fi
+
+ optstring_normalize "$1"
+}
+
+optstring_get_option() {
+ local opts o
+
+ IFS=, read -ra opts <<<"${!1}"
+ for o in "${opts[@]}"; do
+ if optstring_match_option "$2" "$o"; then
+ declare -g "$o"
+ return 0
+ fi
+ done
+
+ return 1
+}
+
+optstring_has_option() {
+ local "${2%%=*}"
+
+ optstring_get_option "$1" "$2"
+}
+
+dm_name_for_devnode() {
+ read dm_name <"/sys/class/block/${1#/dev/}/dm/name"
+ if [[ $dm_name ]]; then
+ printf '/dev/mapper/%s' "$dm_name"
+ else
+ # don't leave the caller hanging, just print the original name
+ # along with the failure.
+ print '%s' "$1"
+ error 'Failed to resolve device mapper name for: %s' "$1"
+ fi
+}
+
+fstype_is_pseudofs() {
+ (( pseudofs_types["$1"] ))
+}
+
+fstype_has_fsck() {
+ (( fsck_types["$1"] ))
+}
+
+
+write_source() {
+ local src=$1 spec= label= uuid= comment=()
+
+ label=$(lsblk -rno LABEL "$1" 2>/dev/null)
+ uuid=$(lsblk -rno UUID "$1" 2>/dev/null)
+
+ # bind mounts do not have a UUID!
+
+ case $bytag in
+ '')
+ [[ $uuid ]] && comment=("UUID=$uuid")
+ [[ $label ]] && comment+=("LABEL=$(mangle "$label")")
+ ;;
+ LABEL)
+ spec=$label
+ [[ $uuid ]] && comment=("$src" "UUID=$uuid")
+ ;;
+ UUID)
+ spec=$uuid
+ comment=("$src")
+ [[ $label ]] && comment+=("LABEL=$(mangle "$label")")
+ ;;
+ *)
+ [[ $uuid ]] && comment=("$1" "UUID=$uuid")
+ [[ $label ]] && comment+=("LABEL=$(mangle "$label")")
+ [[ $bytag ]] && spec=$(lsblk -rno "$bytag" "$1" 2>/dev/null)
+ ;;
+ esac
+
+ [[ $comment ]] && printf '# %s\n' "${comment[*]}"
+
+ if [[ $spec ]]; then
+ printf '%-20s' "$bytag=$(mangle "$spec")"
+ else
+ printf '%-20s' "$(mangle "$src")"
+ fi
+}
+
+optstring_apply_quirks() {
+ local varname=$1 fstype=$2
+
+ # SELinux displays a 'seclabel' option in /proc/self/mountinfo. We can't know
+ # if the system we're generating the fstab for has any support for SELinux (as
+ # one might install Arch from a Fedora environment), so let's remove it.
+ optstring_remove_option "$varname" seclabel
+
+ # Prune 'relatime' option for any pseudofs. This seems to be a rampant
+ # default which the kernel often exports even if the underlying filesystem
+ # doesn't support it. Example: https://bugs.archlinux.org/task/54554.
+ if awk -v fstype="$fstype" '$1 == fstype { exit 1 }' /proc/filesystems; then
+ optstring_remove_option "$varname" relatime
+ fi
+
+ case $fstype in
+ f2fs)
+ # These are Kconfig options for f2fs. Kernels supporting the options will
+ # only provide the negative versions of these (e.g. noacl), and vice versa
+ # for kernels without support.
+ optstring_remove_option "$varname" noacl,acl,nouser_xattr,user_xattr
+ ;;
+ vfat)
+ # Before Linux v3.8, "cp" is prepended to the value of the codepage.
+ if optstring_get_option "$varname" codepage && [[ $codepage = cp* ]]; then
+ optstring_remove_option "$varname" codepage
+ optstring_append_option "$varname" "codepage=${codepage#cp}"
+ fi
+ ;;
+ esac
+}
+
+usage() {
+ cat <<EOF
+usage: ${0##*/} [options] root
+
+ Options:
+ -f <filter> Restrict output to mountpoints matching the prefix FILTER
+ -L Use labels for source identifiers (shortcut for -t LABEL)
+ -p Exclude pseudofs mounts (default behavior)
+ -P Include pseudofs mounts
+ -t <tag> Use TAG for source identifiers (TAG should be one of: LABEL,
+ UUID, PARTLABEL, PARTUUID)
+ -U Use UUIDs for source identifiers (shortcut for -t UUID)
+
+ -h Print this help message
+
+genfstab generates output suitable for addition to an fstab file based on the
+devices mounted under the mountpoint specified by the given root.
+
+EOF
+}
+
+if [[ -z $1 || $1 = @(-h|--help) ]]; then
+ usage
+ exit $(( $# ? 0 : 1 ))
+fi
+
+while getopts ':f:LPpt:U' flag; do
+ case $flag in
+ L)
+ bytag=LABEL
+ ;;
+ U)
+ bytag=UUID
+ ;;
+ f)
+ prefixfilter=$OPTARG
+ ;;
+ P)
+ pseudofs=1
+ ;;
+ p)
+ pseudofs=0
+ ;;
+ t)
+ bytag=${OPTARG^^}
+ ;;
+ :)
+ die '%s: option requires an argument -- '\''%s'\' "${0##*/}" "$OPTARG"
+ ;;
+ ?)
+ die '%s: invalid option -- '\''%s'\' "${0##*/}" "$OPTARG"
+ ;;
+ esac
+done
+shift $(( OPTIND - 1 ))
+
+(( $# )) || die "No root directory specified"
+root=$(realpath -mL "$1"); shift
+
+if ! mountpoint -q "$root"; then
+ die "$root is not a mountpoint"
+fi
+
+# handle block devices
+findmnt -Recvruno SOURCE,TARGET,FSTYPE,OPTIONS,FSROOT "$root" |
+ while read -r src target fstype opts fsroot; do
+ if (( !pseudofs )) && fstype_is_pseudofs "$fstype"; then
+ continue
+ fi
+
+ [[ $target = "$prefixfilter"* ]] || continue
+
+ # default 5th and 6th columns
+ dump=0 pass=2
+
+ src=$(unmangle "$src")
+ target=$(unmangle "$target")
+ target=${target#$root}
+
+ if (( !foundroot )) && findmnt "$src" "$root" >/dev/null; then
+ # this is root. we can't possibly have more than one...
+ pass=1 foundroot=1
+ fi
+
+ # if there's no fsck tool available, then only pass=0 makes sense.
+ if ! fstype_has_fsck "$fstype"; then
+ pass=0
+ fi
+
+ if [[ $fsroot != / ]]; then
+ if [[ $fstype = btrfs ]]; then
+ opts+=,subvol=${fsroot#/}
+ else
+ # it's a bind mount
+ src=$(findmnt -funcevo TARGET "$src")$fsroot
+ if [[ $src -ef $target ]]; then
+ # hrmm, this is weird. we're probably looking at a file or directory
+ # that was bound into a chroot from the host machine. Ignore it,
+ # because this won't actually be a valid mount. Worst case, the user
+ # just re-adds it.
+ continue
+ fi
+ fstype=none
+ opts+=,bind
+ pass=0
+ fi
+ fi
+
+ # filesystem quirks
+ case $fstype in
+ fuseblk)
+ # well-behaved FUSE filesystems will report themselves as fuse.$fstype.
+ # this is probably NTFS-3g, but let's just make sure.
+ if ! newtype=$(lsblk -no FSTYPE "$src") || [[ -z $newtype ]]; then
+ # avoid blanking out fstype, leading to an invalid fstab
+ error 'Failed to derive real filesystem type for FUSE device on %s' "$target"
+ else
+ fstype=$newtype
+ fi
+ ;;
+ esac
+
+ optstring_apply_quirks "opts" "$fstype"
+
+ # write one line
+ write_source "$src"
+ printf '\t%-10s' "/$(mangle "${target#/}")" "$fstype" "$opts"
+ printf '\t%s %s' "$dump" "$pass"
+ printf '\n\n'
+done
+
+# handle swaps devices
+{
+ # ignore header
+ read
+
+ while read -r device type _ _ prio; do
+ options=defaults
+ if (( prio >= 0 )); then
+ options+=,pri=$prio
+ fi
+
+ # skip files marked deleted by the kernel
+ [[ $device = *'\040(deleted)' ]] && continue
+
+ if [[ $type = file ]]; then
+ printf '%-20s' "${device#${root%/}}"
+ elif [[ $device = /dev/dm-+([0-9]) ]]; then
+ # device mapper doesn't allow characters we need to worry
+ # about being mangled, and it does the escaping of dashes
+ # for us in sysfs.
+ write_source "$(dm_name_for_devnode "$device")"
+ else
+ write_source "$(unmangle "$device")"
+ fi
+
+ printf '\t%-10s\t%-10s\t%-10s\t0 0\n\n' 'none' 'swap' "$options"
+ done
+} </proc/swaps
+
+# vim: et ts=2 sw=2 ft=sh:
diff --git a/gentoox_build.sh b/gentoox_build.sh
index 7d87e7d..6f3a54b 100755
--- a/gentoox_build.sh
+++ b/gentoox_build.sh
@@ -52,8 +52,12 @@ if [[ ! -f 'image/etc/gentoo-release' ]]; then
rm -f stage3*
cp ../../$KERNEL_CONFIG_DIFF usr/src
+ mkdir -p etc/portage/patches
+ cp -r ../../patches/* etc/portage/patches/
mkdir -p etc/portage/patches/app-crypt/efitools
cp ../../efitools-1.9.2-fixup-UNKNOWN_GLYPH.patch etc/portage/patches/app-crypt/efitools/
+ cp ../../arch-chroot usr/local/sbin/
+ cp ../../genfstab usr/local/sbin/
if [[ ! -z $binpkgs ]] && [[ ! -z $distfiles ]]; then
#rsync -a $binpkgs var/cache/binpkgs/
@@ -253,7 +257,7 @@ dev-ruby/kpeg ruby_targets_ruby27
dev-ruby/racc ruby_targets_ruby27' >> /etc/portage/package.use/gentoox
emerge -v --autounmask=y --autounmask-write=y --keep-going=y --deep --newuse xorg-server elogind sudo vim weston wpa_supplicant snapper \
-nfs-utils cifs-utils samba dhcpcd nss-mdns zsh zsh-completions powertop lm-sensors #plymouth-openrc-plugin
+nfs-utils cifs-utils samba dhcpcd nss-mdns zsh zsh-completions powertop lm-sensors screenfetch #plymouth-openrc-plugin
#emerge -v --depclean
touch /tmp/gentoox-weston-done
HEREDOC
@@ -280,7 +284,7 @@ sed -i '1s/^/NTHREADS="12"\n/' /etc/portage/make.conf
echo -e '\nkde-plasma/plasma-meta discover networkmanager thunderbolt
kde-apps/kio-extras samba' >> /etc/portage/package.use/gentoox
-emerge -v --jobs=4 --keep-going=y --autounmask=y --autounmask-write=y --deep --newuse kde-plasma/plasma-meta kde-apps/kde-apps-meta kde-apps/kmail latte-dock calamares firefox mpv
+emerge -v --jobs=4 --keep-going=y --autounmask=y --autounmask-write=y --deep --newuse kde-plasma/plasma-meta kde-apps/kde-apps-meta kde-apps/kmail latte-dock calamares gparted plasma-sdk gdb dos2unix qt-creator firefox mpv app-misc/screen
yes | layman -o https://raw.githubusercontent.com/fosero/flatpak-overlay/master/repositories.xml -f -a flatpak-overlay -q
emerge -v sys-apps/flatpak
@@ -347,10 +351,11 @@ fi
if [[ ! -z $configure_user ]] && [[ ! -f 'tmp/gentoox-user-configured' ]]; then
+cp ../../postinstall.sh .
cp ../../1518039301698.png .
+cp '../../GentooX Breeze Dark Transparent.tar.gz' .
cat <<HEREDOC | chroot .
source /etc/profile && export PS1="(chroot) \$PS1"
-
sed -i "s/localhost/gentoox/g" /etc/conf.d/hostname
sed -i "s/127.0.0.1 localhost/127.0.0.1 gentoox.haxx.dafuq gentoox localhost/" /etc/hosts
sed -i "s/::1 localhost/::1 gentoox.haxx.dafuq gentoox localhost/" /etc/hosts
@@ -359,6 +364,16 @@ nis_domain_lo="haxx.local"' > /etc/conf.d/net
echo 'nameserver 1.1.1.1
nameserver 2606:4700:4700::1111' > /etc/resolv.conf
+# theme related
+(cd /usr/share/icons; git clone https://github.com/keeferrourke/la-capitaine-icon-theme.git)
+cd /usr/src/
+git clone https://github.com/ishovkun/SierraBreeze.git
+cd SierraBreeze/
+mkdir build && cd build
+cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DKDE_INSTALL_LIBDIR=lib -DBUILD_TESTING=OFF -DKDE_INSTALL_USE_QT_SYS_PATHS=ON
+make install
+cd /
+
#echo "root:$rootpassword" | chpasswd
yes "$rootpassword" | passwd root
useradd $username
@@ -389,12 +404,15 @@ rc-update add avahi-daemon default
rc-update add samba default
+mv /postinstall.sh /home/$username/
mv /1518039301698.png /home/$username/
+mv '/GentooX Breeze Dark Transparent.tar.gz' /home/$username/
cd /home/$username/
echo 'exec dbus-launch --exit-with-session startplasma-x11' > .xinitrc
chown -R $username /home/$username/
su - gentoox
flatpak --user remote-add --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo
+kpackagetool5 -i "GentooX Breeze Dark Transparent.tar.gz"
touch /tmp/gentoox-user-configured
HEREDOC
@@ -465,7 +483,7 @@ xorriso -as mkisofs -r -J \
-b isolinux/isolinux.bin -c isolinux/boot.cat \
-no-emul-boot -boot-load-size 4 -boot-info-table \
-eltorito-alt-boot -e gentoo.efimg -no-emul-boot -isohybrid-gpt-basdat \
- -V "GentooX Live" -o Gentoox-x86_64-$builddate.iso iso/
+ -V "GentooX Live" -o GentooX-x86_64-$builddate.iso iso/
#rm -Rf image/ iso/ kernel-gentoox.tar.lzma
fi
diff --git a/patches/www-client/firefox/firefox-branded-icons.patch b/patches/www-client/firefox/firefox-branded-icons.patch
new file mode 100644
index 0000000..d7d2552
--- /dev/null
+++ b/patches/www-client/firefox/firefox-branded-icons.patch
@@ -0,0 +1,51 @@
+# HG changeset patch
+# Parent e0751ad74e835e80041a61ea00c2a63bf6fbe2de
+# Parent 127964dc93cc35715852bc811dcc67016d918628
+
+diff --git a/browser/branding/branding-common.mozbuild b/browser/branding/branding-common.mozbuild
+--- a/browser/branding/branding-common.mozbuild
++++ b/browser/branding/branding-common.mozbuild
+@@ -22,12 +22,15 @@ def FirefoxBranding():
+ FINAL_TARGET_FILES.VisualElements += [
+ 'VisualElements_150.png',
+ 'VisualElements_70.png',
+ ]
+ elif CONFIG['MOZ_WIDGET_TOOLKIT'] == 'gtk':
+ FINAL_TARGET_FILES.chrome.icons.default += [
+ 'default128.png',
+ 'default16.png',
++ 'default22.png',
++ 'default24.png',
++ 'default256.png',
+ 'default32.png',
+ 'default48.png',
+ 'default64.png',
+ ]
+diff --git a/browser/installer/package-manifest.in b/browser/installer/package-manifest.in
+--- a/browser/installer/package-manifest.in
++++ b/browser/installer/package-manifest.in
+@@ -246,20 +246,23 @@
+ @RESPATH@/browser/chrome/pdfjs.manifest
+ @RESPATH@/browser/chrome/pdfjs/*
+ @RESPATH@/chrome/toolkit@JAREXT@
+ @RESPATH@/chrome/toolkit.manifest
+ @RESPATH@/chrome/recording.manifest
+ @RESPATH@/chrome/recording/*
+ #ifdef MOZ_GTK
+ @RESPATH@/browser/chrome/icons/default/default16.png
++@RESPATH@/browser/chrome/icons/default/default22.png
++@RESPATH@/browser/chrome/icons/default/default24.png
+ @RESPATH@/browser/chrome/icons/default/default32.png
+ @RESPATH@/browser/chrome/icons/default/default48.png
+ @RESPATH@/browser/chrome/icons/default/default64.png
+ @RESPATH@/browser/chrome/icons/default/default128.png
++@RESPATH@/browser/chrome/icons/default/default256.png
+ #endif
+ @RESPATH@/browser/features/*
+
+ ; [DevTools Startup Files]
+ @RESPATH@/browser/chrome/devtools-startup@JAREXT@
+ @RESPATH@/browser/chrome/devtools-startup.manifest
+
+ ; DevTools
+
diff --git a/patches/www-client/firefox/firefox-kde.patch b/patches/www-client/firefox/firefox-kde.patch
new file mode 100644
index 0000000..cb5578b
--- /dev/null
+++ b/patches/www-client/firefox/firefox-kde.patch
@@ -0,0 +1,283 @@
+# HG changeset patch
+# User msirringhaus@suse.de
+# Date 1559300151 -7200
+# Fri May 31 12:55:51 2019 +0200
+# Node ID 54d41b0033b8d649d842a1f862c6fed8b9874dec
+# Parent 4faaad3619f286bd6077754d8e59d339a5142b80
+How to apply this patch:
+1. Import and apply it
+2. cp browser/base/content/browser.xul browser/base/content/browser-kde.xul
+3. Find editBookmarkPanelDoneButton
+4. Replace #ifndef with #ifdef in the line above (this hanges the button order from Gnome-style to KDE-style)
+5. hg qrefresh
+
+diff --git a/browser/components/preferences/in-content/main.js b/browser/components/preferences/in-content/main.js
+--- a/browser/components/preferences/in-content/main.js
++++ b/browser/components/preferences/in-content/main.js
+@@ -341,16 +341,23 @@ var gMainPane = {
+ }, backoffTimes[this._backoffIndex + 1 < backoffTimes.length ? this._backoffIndex++ : backoffTimes.length - 1]);
+ };
+
+ window.setTimeout(() => {
+ window.requestIdleCallback(pollForDefaultBrowser);
+ }, backoffTimes[this._backoffIndex]);
+ }
+
++ var env = Components.classes["@mozilla.org/process/environment;1"]
++ .getService(Components.interfaces.nsIEnvironment);
++ var kde_session = 0;
++ if (env.get('KDE_FULL_SESSION') == "true") {
++ kde_session = 1;
++ }
++
+ this.initBrowserContainers();
+ this.buildContentProcessCountMenuList();
+
+ let performanceSettingsLink = document.getElementById(
+ "performanceSettingsLearnMore"
+ );
+ let performanceSettingsUrl =
+ Services.urlFormatter.formatURLPref("app.support.baseURL") +
+@@ -1199,16 +1206,27 @@ var gMainPane = {
+ this._backoffIndex = 0;
+
+ let shellSvc = getShellService();
+ if (!shellSvc) {
+ return;
+ }
+ try {
+ shellSvc.setDefaultBrowser(true, false);